'____________________________________________________________________

'                                   VB 106 Project 1  Starter
'                                              Ron Kessler
'                   Use this as the starting point for project 1 if you want

'____________________________________________________________________

'Updated 12/20/2007
'12/20/07   Changed logic in deposit code to make sure they can't enter a blank or negative number.

'completed project and did final testing!


Option Explicit On

Public Class frmMain

    Dim accountBalance As Decimal = 0
    Dim numAttempts As Integer = 0
    Dim msgTitle As String = "Ron's ATM Service"


#Region "Form Load"

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        btnPIN.Enabled = False
        grpCustomer.Visible = False
        grpTransactions.Visible = False
        grpWithDraw.Visible = False
        lblDeposit.Visible = False
        txtDeposit.Visible = False
    End Sub

#End Region

#Region "Get Pin and number of attempts"
    Private Sub btnPIN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPIN.Click
        '---test pin entered to see if it matches
        If txtPin.Text.Trim = My.Resources.custPIN Then
            txtPin.Enabled = False
            btnPIN.Enabled = False

            '---show the transactions
            grpCustomer.Visible = True
            grpTransactions.Visible = True
            grpWithDraw.Visible = False

            '---display customer name and balance
            lblFirst.Text = My.Resources.FirstName
            lblLast.Text = My.Resources.LastName
            lblDate.Text = Date.Now
            lblBalance.Text = My.Resources.acctBalance
            accountBalance = Convert.ToDecimal(My.Resources.acctBalance)
        Else
            '---only let them have 3 tries
            numAttempts += 1
            If numAttempts = 3 Then
                MessageBox.Show("You have exceeded number of chances.", msgTitle, _
                MessageBoxButtons.OK, MessageBoxIcon.Stop)
                Me.Close()
            Else
                MessageBox.Show("Incorrect PIN, guess again!", msgTitle, MessageBoxButtons.OK, _
                MessageBoxIcon.Warning)
                txtPin.Clear()
                txtPin.Focus()
            End If

        End If

    End Sub

#End Region

#Region "Radio button logic"

    Private Sub rdoFastCash_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoFastCash.CheckedChanged
        If rdoFastCash.Checked = True Then
            grpWithDraw.Visible = False
            lblDeposit.Visible = False
            txtDeposit.Visible = False
            txtDeposit.Clear()
        End If
    End Sub
    Private Sub rdoDeposit_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoDeposit.CheckedChanged
        If rdoDeposit.Checked Then
            grpWithDraw.Visible = False
            lblDeposit.Visible = True
            txtDeposit.Visible = True
            txtDeposit.Focus()
        End If
    End Sub

    Private Sub rdoWithdraw_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoWithdraw.CheckedChanged
        If rdoWithdraw.Checked Then
            grpWithDraw.Visible = True
            lblDeposit.Visible = False
            txtDeposit.Visible = False
            txtDeposit.Clear()
        End If
    End Sub

#End Region

    Private Sub txtPin_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPin.TextChanged
        If IsNumeric(txtPin.Text) And txtPin.Text.Length > 0 Then
            btnPIN.Enabled = True
        Else
            btnPIN.Enabled = False
        End If
    End Sub

#Region "BTNOK click"
    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click

        '---fastcash ($40) to be deducted
        If rdoFastCash.Checked Then

            If accountBalance - 40 < 0 Then
                MessageBox.Show("You don't have that much cash.", msgTitle, _
                    MessageBoxButtons.OK, MessageBoxIcon.Stop)
            Else
                accountBalance -= 40
                MessageBox.Show("Please take your cash.", msgTitle, _
                    MessageBoxButtons.OK, MessageBoxIcon.Information)
                lblBalance.Text = accountBalance.ToString

            End If
        End If

        '---did they press deposit?
        If rdoDeposit.Checked = True Then

            If txtDeposit.Text.Trim.Length > 0 Then
                If (IsNumeric(txtDeposit.Text.Trim)) And (CDec(txtDeposit.Text) > 0) Then
                    accountBalance += CDec(txtDeposit.Text.Trim)
                    lblBalance.Text = accountBalance.ToString
                    MessageBox.Show("Your deposit of " & FormatCurrency(txtDeposit.Text) & " was recorded.", _
                     msgTitle, MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
                txtDeposit.Clear()
            End If
        End If

        '---withdrawal ?
        If rdoWithdraw.Checked Then
            Dim amt2WithDraw As Decimal = 0

            If rdo20.Checked Then
                amt2WithDraw = 20
            ElseIf rdo40.Checked Then
                amt2WithDraw = 40
            ElseIf rdo60.Checked Then
                amt2WithDraw = 60
            ElseIf rdo100.Checked Then
                amt2WithDraw = 100
            Else
                MessageBox.Show("Please select an amount to withdraw.", msgTitle, _
                 MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If

            If accountBalance - amt2WithDraw < 0 Then
                MessageBox.Show("You don't have that much cash.", msgTitle, _
                                    MessageBoxButtons.OK, MessageBoxIcon.Stop)


            Else
                accountBalance -= amt2WithDraw
                'accountBalance = accountBalance - amt2WithDraw

                lblBalance.Text = accountBalance.ToString
                MessageBox.Show("Your withdrawal of " & FormatCurrency(amt2WithDraw) & " was recorded.", _
                              msgTitle, MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If

        End If



    End Sub
#End Region

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        If MessageBox.Show("Are you sure?", msgTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Question) _
            = Windows.Forms.DialogResult.Yes Then
            Me.Close()
        End If
    End Sub
End Class
